<?php
if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

if(!defined('CACHE_PATH')){
	define('CACHE_PATH', dirname(dirname(dirname(dirname(dirname(dirname(dirname(__FILE__))))))).'/cache/');
}
require_once(dirname(dirname(dirname(__FILE__))).'/extensions/request_remote.php');

class public_123flashchat_123flashchat_performerlist extends ipsCommand
{
	/**
	 * Temporary HTML output
	 *
	 * @access	private
	 * @var		string
	 */
	private $output				= "";

	/**
	 * Page title
	 *
	 * @access	private
	 * @var		string
	 */
	private $page_title			= "";


	/**
	 * Class entry point
	 *
	 * @access	public
	 * @param	object		Registry reference
	 * @return	void		[Outputs to screen/redirects]
	 */
	public function doExecute( ipsRegistry $registry ){
		/* Make sure the calednar is installed and enabled */
		if( ! IPSLib::appIsInstalled( '123flashchat' ) ){
			$this->registry->output->showError( 'no_permission', 1076 );
		}
		
		/* Load language  */
		$this->registry->class_localization->loadLanguageFile( array( 'public_123flashchat' ) );

		/* Page Title */
		if( $this->page_title == "" ){
			$this->page_title = $this->lang->words['performer_list_page_title'] . " - " . $this->settings['board_name'];
		}
		$fcsetting = $this->get_fc_config();
		/* Output */
		$this->output .= $this->registry->output->getTemplate('123flashchat')->performerlist($this->fc_get_camshowlist($fcsetting),$fcsetting);		
		$this->registry->output->addContent( $this->output );
		$this->registry->output->setTitle( $this->page_title );		
		$this->registry->output->addNavigation( $this->lang->words['page_title'], 'app=123flashchat&module=123flashchat', "false", 'performerlist' );
		$this->registry->output->addNavigation( '123 Cam Show', 'app=123flashchat&module=123flashchat&section=performerlist',"false",'123flashchat' );
		$this->registry->output->sendOutput();
		
	}
	
	public function fc_get_camshowlist($fcsetting){
		$opts = array('http'=>array('timeout'=>3,));
		$context = stream_context_create($opts); 
        $data = topcmmRequestRemote::requestRemote(CACHE_PATH."camshow.js",1);
		$camshow_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$camshow_json){
	    	$camshow_js = '';
		    if($fcsetting['fc_extendserver'] == 2){
				return false;
			}elseif($fcsetting['fc_extendserver'] == 1){
				$camshow_js = topcmmRequestRemote::requestRemote($fcsetting['fc_api_url']."camshow.js?group=".$fcsetting['fc_group'],1);
			}else{
				$camshow_js = topcmmRequestRemote::requestRemote($fcsetting['fc_api_url']."camshow.js",1);
			}
			$camshow_json = substr($camshow_js,12,-1);
	        @file_put_contents(CACHE_PATH."camshow.js",(time() + 60) . $camshow_json);
	    }
	    $camshow_arr = json_decode($camshow_json);
	    if($camshow_arr){
	    	foreach ($camshow_arr as $key => $value){
	    		if(substr($value->logo, 0,3) != '../' && substr($value->logo, 0,7) != 'http://'){
		    		$camshow_arr[$key]->logo =  $fcsetting['fc_api_url'].$value->logo;
		    	}else{
		    		$camshow_arr[$key]->logo =  str_replace('../', $fcsetting['fc_api_url'], $value->logo);
		    	}
	    		$camshow_arr[$key]->url = 'index.php?app=123flashchat&module=123flashchat&room='.$value->id;
	    	}
	    	return $camshow_arr;
	    }else{
	    	return false;
	    }
	}
	
	public function get_fc_config(){
		$this->DB->build( array( 'select' => '*',
			'from'   => '123flashchat',
			'where'  => "id=1")
		);
		$this->DB->execute();
		$result = $this->DB->fetch();
		return $result;
	}
}